<template>
<v-container class="mx-0 pt-0 mt-0" style="max-width:100%">
	<v-snackbar v-model="snackbar.show" left  :color="snackbarColor" timeout="7000" @click="snackbar.show=false">
			<v-icon  class="pb-1 pr-1">{{snackbarIcon}}</v-icon>
			{{ snackbar.text }}
				<template v-slot:action="{ attrs }">
				<v-btn
					icon
					v-bind="attrs"
					@click="snackbar.show = false"
				>
					<v-icon>close</v-icon>
				</v-btn>
				</template>
		</v-snackbar>

		<v-row>
			<v-col cols="12" class="mt-0 pt-0">
				<v-data-table
					
					disable-sort
					fixed-header
					:search="search"
					:loading="loading"
					loading-text="Cargando... Por favor espere"
					:headers="headers"
					:items="plantillas"
					class="elevation-1"
				>
				<template v-slot:top>
					<v-row justify="end" class="mx-1" style="border-bottom:1px solid lightgrey">
						<v-col cols="12" class="px-0 mx-0 py-2">
							<v-text-field
                solo
								dense
								v-model="search" class="shadow"
								prepend-inner-icon="filter_list"
								label="Filtrar"
								single-line
								hide-details
							></v-text-field>
						</v-col>
					</v-row>
				</template>
					<template v-slot:item.actions="{ item }">
						<v-icon
							small
							class="mr-2"
							@click="editItem(item)"
						>
							mdi-pencil
						</v-icon>
						<v-icon
							small
							@click="deleteItem(item)"
						>
							mdi-delete
						</v-icon>
					</template>
					<template v-slot:no-data>
						<v-btn
							color="primary"
							@click="fetchPlantillas()"
						>
							Reset
						</v-btn>
					</template>
				</v-data-table>
			</v-col>
		</v-row>
		<v-row>
			<div style="height:58px;position: relative">

				<v-btn
					color="primary"
					dark
					bottom
					right
					fab
					style="right:10px;bottom:25px;position:fixed"
					@click="nuevo"
				>
					<v-icon>mdi-plus</v-icon>
				</v-btn>
			</div>
		</v-row>


	<v-dialog
		v-model="dialog"
		@click:outside="close"
		max-width="700px"
		fullscreen
		hide-overlay
		transition="dialog-bottom-transition"
	>
		<v-toolbar
			dark
			color="primary"
		>
			<v-btn
				icon
				dark
				@click="close"
			>
				<v-icon>mdi-close</v-icon>
			</v-btn>
			<v-toolbar-title>{{ formTitle }}</v-toolbar-title>
			<v-spacer></v-spacer>
			<v-toolbar-items>
				<v-btn
					class="d-none d-sm-flex"
					dark
					text
					@click="putPlantilla"
					:disabled="!valid"
				>
					Aceptar
				</v-btn>
			</v-toolbar-items>
			<v-btn
					class="d-xs-flex d-sm-none"
					dark
					icon
					@click="putPlantilla"
					:disabled="!valid"
				>
					<v-icon>done</v-icon>
				</v-btn>
		</v-toolbar>
		<v-card>
			<v-card-text>
				<v-container class="ma-0 pa-0" style="max-width:100%">
					<v-form v-model="valid" lazy-validation ref="form" class="pt-5">
						<v-row >
						<v-col
							cols="12"
							sm="6"
							md="6"
							lg="6"
							xl="6"
						>
								<v-text-field
								required
								:rules="[REGLAS.sinEspacios, REGLAS.requerido]"
								:loading="loadingField"
								:disabled="editando ? true : false"
								v-model="plantillaActual.nombre"
								label="Nombre de la plantilla"
							></v-text-field>
						</v-col>
					</v-row>
					<v-row>
						<v-col
							cols="12"
						>
							<v-textarea
								required
								:rules="[REGLAS.requerido]"
								:loading="loadingField"
								class="font"
								auto-grow
								label="Plantilla"
								v-model="plantillaActual.contenido"
								rows="3"
								row-height="25"
							></v-textarea>
						</v-col>
					</v-row>

					
							</v-form>
				</v-container>
			</v-card-text>
		</v-card>
	</v-dialog>

	<v-dialog
			v-model="dialogDelete"
			width="400"
		>
			<v-card>
				<v-card-title>¿Está seguro de que quiere eliminar?</v-card-title>
				<v-card-text>
					<v-row>
						<v-col
							cols="12"
							>
						Al eliminar no podrá recuperarlo
						</v-col>
					</v-row>
				</v-card-text>
				<v-divider></v-divider>
				<v-card-actions>
					<v-spacer></v-spacer>
					<v-btn
						color="grey"
						text
						@click="closeDelete"
					>
						Volver
					</v-btn>
					<v-btn
						color="error"
						text
						@click="deleteItemConfirm"
					>
						Eliminar
					</v-btn>
				</v-card-actions>
			</v-card>
		</v-dialog>

	
</v-container>

    

</template>
<script>
	export default {

		computed: {


		snackbarIcon(){
			if(this.snackbar.create){
				return "check_circle"
			}else if(this.snackbar.delete){
				return 'delete'
			}else if(this.snackbar.error){
				return 'error'
			}else{
				return 'done'
			}
			
		},
		
		snackbarColor(){
			if(this.snackbar.create){
				return 'success'
			}else if(this.snackbar.delete){
				return 'success'
			}else if(this.snackbar.error){
				return 'error'
			}else{
				return 'success'
			}
			
		},

			formTitle () {
				return this.editando ? 'Editar Plantilla' : 'Nueva plantilla'
			},

			mobile(){
				if(this.$vuetify.breakpoint.name == 'xs'){
					return true
				}
				return false
			}
		},
	
		watch: {
			dialog (val) {
				val || this.close()
			},
			dialogDelete (val) {
				val || this.closeDelete()
			},
		},
		
		async mounted() {
			await	this.fetchPlantillas()
		}, 
	
		methods:{
			fetchPlantillas() {
				this.loading = true
				fetch('/api/plantillas')
					.then(response => response.json())
					.then(data => {
						this.plantillas = data.map((str, index) => ({ value: str, id: index + 1 }));
						this.loading = false
					});
			},
			
			nuevo(){
				this.dialog=true
				this.editando=false
			},

			fetchPlantilla(nombre) {
				this.loadingField = true
				fetch('/api/plantillas/'+nombre)
					.then(response => response.text())
					.then(data => {
						//this.plantillas = data.map((str, index) => ({ value: str, id: index + 1 }));
						this.plantillaActual.nombre=nombre
						this.plantillaActual.contenido=data
						this.loadingField=false
					});
			},

			putPlantilla() {
				this.$refs.form.validate()
				this.loading = true
				let nombre = this.plantillaActual.nombre
				fetch('/api/plantillas/'+nombre,{method:"PUT",body:this.plantillaActual.contenido})
					.then(async (response) => {
					if(response.ok){
					this.fetchPlantillas()
					this.snackbar = {
							text: 'Plantilla creada con éxito',
							show: true,
							create:true,
					}
					}else{
						let texto = await response.text()
						throw new Error(texto)
						
					}
				})
				
				.catch((error) => {
						this.snackbar = {
							text: error,
							show: true,
							error:true,
					}

				})
				.finally(() => {
					this.close()
					this.fetchPlantillas()
					this.loading=false
					this.$refs.form.reset()

				})
				this.close()
				this.fetchPlantillas()
				this.$refs.form.reset()
			},

			editItem (item) {
				let plantilla = item.value.replace('templates/','')
				this.fetchPlantilla(plantilla)
				//this.editedIndex = this.plantillas.indexOf(item)
				//this.editedItem = Object.assign({}, item)
				this.dialog = true
				this.editando=true
			},

			deleteItem (item) {
				this.dialogDelete = true
				let plantilla = item.value.replace('templates/','')
				this.fetchPlantilla(plantilla)
			},

			deleteItemConfirm () {
				this.loading = true
				let nombre = this.plantillaActual.nombre
				fetch('/api/plantillas/'+nombre,{method:"DELETE",body:this.plantillaActual.contenido})
					.then(async (response) => {
					if(response.ok){
					this.fetchPlantillas()
					this.snackbar = {
							text: 'Plantilla eliminada',
							show: true,
							delete:true,
					}
					}else{
						let texto = await response.text()
						throw new Error(texto)
						
					}
				})
				
				.catch((error) => {
						this.snackbar = {
							text: error,
							show: true,
							error:true,
					}

				})
				.finally(() => {
					this.closeDelete()
					this.fetchPlantillas()
					this.loading=false

				})
					
					this.closeDelete()
					this.fetchPlantillas()
			},
				


			close () {
				this.dialog = false
				this.plantillaActual.nombre=''
				this.plantillaActual.contenido=''
			},

			closeDelete () {
				this.dialogDelete = false
				this.$nextTick(() => {
					this.editedItem = Object.assign({}, this.defaultItem)
					this.editedIndex = -1
				})
			},


			// onDelete(entorno){
			// 	if(entorno.Nombre) {
			// 		this.loading = true
			// 		fetch(`/api/entornos/${entorno.Nombre}`, {
			// 			method: 'DELETE',
			// 			})
			// 			// .then(response => response.json())
			// 			.then(data => {
			// 				console.log(data)
			// 				this.loading = false
			// 				this.fetchEntornos()
			// 			});
			// 	}
			// },
			// onCreate(){
			// 	let data = {}
			// 	data.nombre = prompt("Nombre del entorno")
			// 	data.template = prompt("Plantilla")
			// 	if(data.nombre && data.template) {
			// 		this.loading = true
			// 		fetch(`/api/entornos/`, {
			// 			method: 'POST',
			// 			body: JSON.stringify(data)
			// 			})
			// 			// .then(response => response.json())
			// 			.then(data => {
			// 				console.log(data)
			// 				this.loading = false
			// 				this.fetchEntornos()
			// 			});
			// 	}
			// }
		},
		data(){
			return {
				search: '',
				plantillaActual:{
					nombre:null,
					contenido:null,
				},
				editando:false,
				loading: true,
				plantillaEliminar:null,
				loadingField:false,
				dialog: false,
				dialogDelete: false,
				headers: [
					{
						text: 'Plantillas',
						align: 'start',
						sortable: true,
						value: 'value',
					},
					{ text: 'Acción', value: 'actions', sortable: false, width:80},
				],
				plantillas: [],
				editedIndex: -1,
				editedItem: {
					plantillas: '',
					},
				defaultItem: {
					plantillas: '',
				},

				valid: false,

				REGLAS: {
					sinEspacios: (v) => !v || !!/^[^ ]*$/.test(v) || "El campo no puede contener espacios",
					requerido: (v) => !!v || "Debe completar este campo",
				},
				snackbar: {
					show: false,
					text: '',
					delete:false,
					create:false,
					error:false,
				},
			}
		}
	}

</script>

<style lang="scss" scoped>
@import url('https://fonts.googleapis.com/css2?family=Source+Code+Pro:wght@200;300;400;500;600;700;900&display=swap');
@import "../scss/breakpoints.scss";

::v-deep .v-textarea textarea{
 font-family: 'Source Code Pro', monospace;
 line-height:1.5;
 font-size:small;
}

::v-deep .v-data-table-header-mobile{

		display:none;

}

::v-deep .shadow .v-input__slot{
	box-shadow:none !important;
}
</style>